with OCI.Thick.Connections;
with OCI.Thick.Statements;
with Text_IO;
with OCI.Lib;
with OCI.Thick.Strings;
with Ada.Strings.Fixed;
with Interfaces.C;
with Ada.Exceptions;
with GNAT.Traceback.Symbolic;
procedure dyn is
  use OCI.Thick;
  use OCI.Thick.Connections;
  use OCI.Thick.Statements;
  use Interfaces.C;
  use OCI.Thick.Strings;
  use Ada.Strings.Fixed;
  
  Connect : Connection := Logon ("scott/tiger");
  Stmt : Statement := Prepare
     (Connect, 
      "begin"
        & " if true then"
        & " :result1 := nvl(:result1, 'eeeeeeeeeeeee');"
        & " end if;"
      & " end;");
  Sel : Statement := Prepare (Connect, 
      "select * from ("
      & " select rownum || ', '|| dname ||', '|| loc ||';' from dept"
      & " union select rownum || ', '||  loc ||', '|| dname ||';' from dept"
      & " union select loc  || ', '||  rownum ||', '|| dname ||';' from dept"
      & " union select loc  || ', '||  dname ||', '|| rownum ||';' from dept"
      & " union select dname || ', '|| loc   ||', '|| rownum ||';' from dept"
      & " union select dname || ', '|| rownum  ||', '|| loc  ||';' from dept"
      & " union all select '22' from dept"
      & " union all select '2' from dept"
      & " union all select null from dept"
      & " union all select '=====================' from dept)"
      & " where rownum < :cond");
  Result1 : Var_Type;
  Result2 : Var_Type;
begin

   Bind (Stmt, Result1, "result1");
   Define (Sel, Result1, 1);
   Bind (sel, Result2, "cond");
   Text_IO.Put_Line ("binded");
   Set_Value (Result1, 2 * "aBcDeFgH." & "=_");
   Text_IO.Put ("execute");
   Execute (Stmt);
   Text_IO.Put_Line ("d");
   Text_IO.Put_Line ("Result1 " & Value (Result1) & ';');
   Clear_Value (Result1);
   Execute (Stmt);
   Text_IO.Put_Line ("d");
   Text_IO.Put_Line ("Result1 " & Value (Result1) & ';');
   Set_Value (Result2, "97");
   Execute (Sel);
   while Fetch(Sel) loop
      if IS_Null (Result1) then
        Text_IO.Put_Line ("(null)");
      else
         declare
            f1 : String := Value (Result1);  
         begin
            Text_IO.Put_Line (f1 & '.' 
              & Integer'Image (Character'Pos (F1 (F1'Last))));
         end;
      end if;
   end loop;
exception
   when E : others =>
      Text_IO.Put_Line(Ada.Exceptions.Exception_Information(E));
      Text_IO.Put_Line("----------");
      Text_IO.Put_Line(GNAT.Traceback.Symbolic.Symbolic_Traceback(E));
end dyn;